package cn.minbb.serial.utils;

import android.os.Environment;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class FileUtil {

    // 路径为 /sdcard/[appName]/log.txt
    private static final String appName = "A";
    private static File file;

    static {
        file = new File(Environment.getExternalStorageDirectory(), appName);
        if (!file.exists()) {
            file.mkdirs();
        }
        file = new File(file, "log.txt");
    }

    /**
     * 将文本追加写入到文件
     */
    public static void setAppendFile(String value) {
        try {
            FileWriter fw = new FileWriter(file, true);
            BufferedWriter bw = new BufferedWriter(fw);
            PrintWriter printWriter = new PrintWriter(bw);
            printWriter.print(SimpleDateFormat.getDateTimeInstance().format(new Date()) + ":\n");
            printWriter.println(value);
            printWriter.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 将异常信息写入到文件
     */
    public static void setAppendFile(Throwable ex) {
        // Throwable ex
        try {
            FileWriter fw = new FileWriter(file, true);
            BufferedWriter bw = new BufferedWriter(fw);
            PrintWriter printWriter = new PrintWriter(bw);
            printWriter.println(SimpleDateFormat.getDateTimeInstance().format(new Date()) + ":\n");
            ex.printStackTrace(printWriter);
            printWriter.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
