package cn.minbb.serialport.handler;

import java.io.FileInputStream;
import java.io.FileOutputStream;

import cn.minbb.serialport.listener.OnDataProgressListener;

public class SendDataContext<T> {

    private FileInputStream fileInputStream;
    private FileOutputStream fileOutputStream;
    private OnDataProgressListener onDataProgressListener;
    private SendDataHandler<T> sendDataHandler;

    public SendDataContext(FileInputStream fileInputStream, FileOutputStream fileOutputStream, OnDataProgressListener onDataProgressListener, SendDataHandler<T> sendDataHandler) {
        this.fileInputStream = fileInputStream;
        this.fileOutputStream = fileOutputStream;
        this.onDataProgressListener = onDataProgressListener;
        this.sendDataHandler = sendDataHandler;
    }

    public void doSend(T t) throws Exception {
        if (null == fileInputStream) throw new RuntimeException("文件输入流为空");
        if (null == fileOutputStream) throw new RuntimeException("文件输出流为空");
        if (null == sendDataHandler) throw new RuntimeException("未设置发送数据处理器");
        sendDataHandler.send(fileInputStream, fileOutputStream, onDataProgressListener, t);
    }

    public void setFileInputStream(FileInputStream fileInputStream) {
        this.fileInputStream = fileInputStream;
    }

    public void setFileOutputStream(FileOutputStream fileOutputStream) {
        this.fileOutputStream = fileOutputStream;
    }

    public void setOnDataProgressListener(OnDataProgressListener onDataProgressListener) {
        this.onDataProgressListener = onDataProgressListener;
    }

    public void setSendDataHandler(SendDataHandler<T> sendDataHandler) {
        this.sendDataHandler = sendDataHandler;
    }
}
