package cn.minbb.serialport.impl;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Arrays;

import cn.minbb.serialport.handler.SendDataHandler;
import cn.minbb.serialport.listener.OnDataProgressListener;
import cn.minbb.serialport.utils.LogUtil;

public class SendDataStringImpl implements SendDataHandler<String> {

    @Override
    public void send(FileInputStream fileInputStream, FileOutputStream fileOutputStream, OnDataProgressListener onDataProgressListener, String s) throws IOException {
        byte[] dataBytes = s.getBytes(Charset.forName("UTF-8"));
        LogUtil.setAppendFile("发送字符：[" + s + "] -> " + Arrays.toString(dataBytes));
        // 分包，发送数据
        fileOutputStream.write(dataBytes);
        byte[] buffer = new byte[64];
        int length;
        while ((length = fileInputStream.read(buffer)) != -1) {
            System.out.println(new String(buffer, 0, length));
            if (null != onDataProgressListener) {
                onDataProgressListener.onProgress(0, 0, 0, buffer);
            }
        }
    }
}
