package cn.minbb.serialport.utils;

public class HexUtil {

    private static final char[] DIGITS_LOWER;
    private static final char[] DIGITS_UPPER;

    static {
        char[] arrayOfChar1 = new char[16];
        arrayOfChar1[0] = 48;
        arrayOfChar1[1] = 49;
        arrayOfChar1[2] = 50;
        arrayOfChar1[3] = 51;
        arrayOfChar1[4] = 52;
        arrayOfChar1[5] = 53;
        arrayOfChar1[6] = 54;
        arrayOfChar1[7] = 55;
        arrayOfChar1[8] = 56;
        arrayOfChar1[9] = 57;
        arrayOfChar1[10] = 97;
        arrayOfChar1[11] = 98;
        arrayOfChar1[12] = 99;
        arrayOfChar1[13] = 100;
        arrayOfChar1[14] = 101;
        arrayOfChar1[15] = 102;
        DIGITS_LOWER = arrayOfChar1;
        char[] arrayOfChar2 = new char[16];
        arrayOfChar2[0] = 48;
        arrayOfChar2[1] = 49;
        arrayOfChar2[2] = 50;
        arrayOfChar2[3] = 51;
        arrayOfChar2[4] = 52;
        arrayOfChar2[5] = 53;
        arrayOfChar2[6] = 54;
        arrayOfChar2[7] = 55;
        arrayOfChar2[8] = 56;
        arrayOfChar2[9] = 57;
        arrayOfChar2[10] = 65;
        arrayOfChar2[11] = 66;
        arrayOfChar2[12] = 67;
        arrayOfChar2[13] = 68;
        arrayOfChar2[14] = 69;
        arrayOfChar2[15] = 70;
        DIGITS_UPPER = arrayOfChar2;
    }

    public static byte[] decodeHex(char[] paramArrayOfChar) {
        int i = paramArrayOfChar.length;
        if ((i & 0x1) != 0)
            throw new RuntimeException("Odd number of characters.");
        byte[] arrayOfByte = new byte[i >> 1];
        int j = 0;
        int k = 0;
        while (k < i) {
            int l = toDigit(paramArrayOfChar[k], k) << 4;
            int i1 = k + 1;
            int i2 = l | toDigit(paramArrayOfChar[i1], i1);
            k = i1 + 1;
            arrayOfByte[j] = (byte) (i2 & 0xFF);
            ++j;
        }
        return arrayOfByte;
    }

    public static char[] encodeHex(byte[] paramArrayOfByte) {
        return encodeHex(paramArrayOfByte, true);
    }

    public static char[] encodeHex(byte[] paramArrayOfByte, boolean paramBoolean) {
        if (paramBoolean) ;
        for (char[] arrayOfChar = DIGITS_LOWER; ; arrayOfChar = DIGITS_UPPER)
            return encodeHex(paramArrayOfByte, arrayOfChar);
    }

    protected static char[] encodeHex(byte[] paramArrayOfByte, char[] paramArrayOfChar) {
        int i = paramArrayOfByte.length;
        char[] arrayOfChar = new char[i << 1];
        int j = 0;
        int k = 0;
        while (j < i) {
            int l = k + 1;
            arrayOfChar[k] = paramArrayOfChar[((0xF0 & paramArrayOfByte[j]) >>> 4)];
            k = l + 1;
            arrayOfChar[l] = paramArrayOfChar[(0xF & paramArrayOfByte[j])];
            ++j;
        }
        return arrayOfChar;
    }

    public static String encodeHexStr(byte[] paramArrayOfByte) {
        return encodeHexStr(paramArrayOfByte, true);
    }

    public static String encodeHexStr(byte[] paramArrayOfByte, boolean paramBoolean) {
        if (paramBoolean) ;
        for (char[] arrayOfChar = DIGITS_LOWER; ; arrayOfChar = DIGITS_UPPER)
            return encodeHexStr(paramArrayOfByte, arrayOfChar);
    }

    protected static String encodeHexStr(byte[] paramArrayOfByte, char[] paramArrayOfChar) {
        return new String(encodeHex(paramArrayOfByte, paramArrayOfChar));
    }

    protected static int toDigit(char paramChar, int paramInt) {
        int i = Character.digit(paramChar, 16);
        if (i == -1)
            throw new RuntimeException("Illegal hexadecimal character " + paramChar + " at index " + paramInt);
        return i;
    }
}
